commit 43619dc6e120a80305d4a52d7f9b8833c110a7db
Author: Alex Coplan <alex.coplan@arm.com>
Date:   Thu May 25 14:34:46 2023

    arm: Fix ICE due to infinite splitting [PR109800]
    
    In r11-966-g9a182ef9ee011935d827ab5c6c9a7cd8e22257d8 we introduce a
    simplification to emit_move_insn that attempts to simplify moves of the form:
    
    (set (subreg:M1 (reg:M2 ...)) (constant C))
    
    where M1 and M2 are of equal mode size. That is problematic for the splitter
    vfp.md:no_literal_pool_df_immediate in the arm backend, which tries to pun an
    lvalue DFmode pseudo into DImode and assign a constant to it with
    emit_move_insn, as the new transformation simply undoes this, and we end up
    splitting indefinitely.
    
    This patch changes things around in the arm backend so that we use a
    DImode temporary (instead of DFmode) and first load the DImode constant
    into the pseudo, and then pun the pseudo into DFmode as an rvalue in a
    reg -> reg move. I believe this should be semantically equivalent but
    avoids the pathalogical behaviour seen in the PR.
    
    gcc/ChangeLog:
    
            PR target/109800
            * config/arm/arm.md (movdf): Generate temporary pseudo in DImode
            instead of DFmode.
            * config/arm/vfp.md (no_literal_pool_df_immediate): Rather than punning an
            lvalue DFmode pseudo into DImode, use a DImode pseudo and pun it into
            DFmode as an rvalue.
    
    gcc/testsuite/ChangeLog:
    
            PR target/109800
            * gcc.target/arm/pure-code/pr109800.c: New test.
    
    (cherry picked from commit f5298d9969b4fa34ff3aecd54b9630e22b2984a5)

diff --git a/gcc/testsuite/gcc.target/arm/pure-code/pr109800.c b/gcc/testsuite/gcc.target/arm/pure-code/pr109800.c
new file mode 100644
index 00000000000..d797b790232
--- /dev/null
+++ b/gcc/testsuite/gcc.target/arm/pure-code/pr109800.c
@@ -0,0 +1,4 @@
+/* { dg-do compile } */
+/* { dg-require-effective-target arm_hard_ok } */
+/* { dg-options "-O2 -march=armv7-m -mfloat-abi=hard -mfpu=fpv4-sp-d16 -mbig-endian -mpure-code" } */
+double f() { return 5.0; }

